# FTL Save File Manager
## Status
As of version **0.4.2**, the program now replicates the functionality of the original Visual Basic tool I wrote in high school, rewritten in Python with a terminal-based UI.

## Description
- The **FTL Savemanager** allows you to save and load progress in the game Faster Than Light (FTL).
- **Backup:** Automatically backs up save files after a jump.
- **Restore:** Can restore save files, but only when the game is at the main menu.
- **Profile Backup:** Includes the option to back up the profile file, which tracks overall progress (e.g., unlocked ships).
- The tool features a simple terminal-based menu system, allowing easy navigation and configuration of settings.

**Gif showing program in action**

![ftl-demo.gif](https://code.boxyfoxy.net/CodeByMrFinchum/ftl-save-manager/raw/branch/main/demo.gif)


## Limitations
- Currently only works on Linux.
- Dependencies include requests and simple-term-menu.
- **Future Optimization**
    - Settings currently use a simple text file (mirroring the original project), though migration to YAML is planned.
    - Some functions may have codependencies that need refinement.

## Installation
**Dependencies**
- Python 3.6 or newer (used 3.13.1).
- requests
- simple-term-menu

**Installation Options**
- Using pip
```bash
pip install requests simple-term-menu
```
Using Conda (or its other flavours, i.e. miniconda, mamba, micromamba)
Install Miniconda or Mamba.

Create a new environment and install the dependencies:
```bash
conda create -n ftl_manager requests simple-term-menu -y
conda activate ftl_manager
```
Download th ftl-savemanager.py and start with
```bash
python ftl-savemanager.py
```
## Additional Notes
This project was developed with the assistance of Large Language Models (LLMs) including, but not limited to, OpenAI's ChatGPT and models such as OpenCoder.

LLMs contributed through spelling corrections, function suggestions, and debugging discussions, which are not explicitly labeled. Direct optimizations made by LLMs are annotated in the code.


### References

1. **Huang, Siming, et al.**
   *OpenCoder: The Open Cookbook for Top-Tier Code Large Language Models.*
   2024. [PDF](https://arxiv.org/pdf/2411.04905)
